import type { Position as CMPosition, EditorChange } from "codemirror";
import type { Position, Range, DiagnosticSeverity, DiagnosticTag, CompletionItem, CompletionList, CompletionItemKind, SymbolKind, TextDocumentContentChangeEvent } from "vscode-languageserver-protocol";
import { MarkupContent, MarkedString } from "vscode-languageserver-protocol";
export declare const lspPosition: ({ line, ch }: CMPosition) => Position;
export declare const lspRange: (start: CMPosition, end: CMPosition) => Range;
export declare const lspChange: (change: EditorChange) => TextDocumentContentChangeEvent;
export declare const cmPosition: ({ line, character }: Position) => CMPosition;
export declare const cmRange: ({ start, end }: Range) => [CMPosition, CMPosition];
export declare const diagnosticSeverityName: (severity: DiagnosticSeverity) => string;
export declare const diagnosticTagName: (tag: DiagnosticTag) => string;
export declare const documentationToString: (doc?: string | MarkupContent, renderMarkdown?: (x: string) => string) => string;
export declare const hoverContentsToString: (contents: MarkupContent | MarkedString | MarkedString[], renderMarkdown: (x: string) => string) => string;
export declare const completionItemKindToString: (kind?: CompletionItemKind) => string;
export declare const symbolKindToString: (kind?: SymbolKind) => string;
export declare const completionItemsToList: (items: CompletionItem[]) => CompletionList;
