export declare type Subscriber<T> = (x: T) => void;
export declare type Disposer = () => void;
export declare type Stream<T> = (cb: Subscriber<T>) => Disposer;
export interface DomEventTarget<K extends keyof HTMLElementEventMap> {
    addEventListener(type: string, listener: (x: HTMLElementEventMap[K]) => void): void;
    removeEventListener(type: string, listener?: (x: HTMLElementEventMap[K]) => void): void;
}
export declare const fromDomEvent: <K extends keyof HTMLElementEventMap>(target: DomEventTarget<K>, type: K) => Stream<HTMLElementEventMap[K]>;
export declare const map: <T, U>(transform: (x: T) => U) => (stream: Stream<T>) => Stream<U>;
export declare const tap: <T>(effect: (x: T) => void) => (stream: Stream<T>) => Stream<T>;
export declare const skipDuplicates: <T>(equals?: (prev: T, next: T) => boolean) => (stream: Stream<T>) => Stream<T>;
export declare const debounce: <T>(ms: number) => (stream: Stream<T>) => Stream<T>;
export declare const debouncedBuffer: <T>(ms: number) => (stream: Stream<T>) => Stream<T[]>;
export declare const filter: <T>(test: (x: T) => boolean) => (stream: Stream<T>) => Stream<T>;
export declare const piped: Piped;
export declare type UnknownUnaryFunction = (param: unknown) => unknown;
export declare type Piped = {
    <A, B>(a: A, ab: (this: void, a: A) => B): B;
    <A, B, C>(a: A, ab: (this: void, a: A) => B, bc: (this: void, b: B) => C): C;
    <A, B, C, D>(a: A, ab: (this: void, a: A) => B, bc: (this: void, b: B) => C, cd: (this: void, c: C) => D): D;
    <A, B, C, D, E>(a: A, ab: (this: void, a: A) => B, bc: (this: void, b: B) => C, cd: (this: void, c: C) => D, de: (this: void, d: D) => E): E;
    <A, B, C, D, E, F>(a: A, ab: (this: void, a: A) => B, bc: (this: void, b: B) => C, cd: (this: void, c: C) => D, de: (this: void, d: D) => E, ef: (this: void, e: E) => F): F;
    <A, B, C, D, E, F, G>(a: A, ab: (this: void, a: A) => B, bc: (this: void, b: B) => C, cd: (this: void, c: C) => D, de: (this: void, d: D) => E, ef: (this: void, e: E) => F, fg: (this: void, f: F) => G): G;
    <A, B, C, D, E, F, G, H>(a: A, ab: (this: void, a: A) => B, bc: (this: void, b: B) => C, cd: (this: void, c: C) => D, de: (this: void, d: D) => E, ef: (this: void, e: E) => F, fg: (this: void, f: F) => G, gh: (this: void, g: G) => H): H;
    <A, B, C, D, E, F, G, H, I>(a: A, ab: (this: void, a: A) => B, bc: (this: void, b: B) => C, cd: (this: void, c: C) => D, de: (this: void, d: D) => E, ef: (this: void, e: E) => F, fg: (this: void, f: F) => G, gh: (this: void, g: G) => H, hi: (this: void, h: H) => I): I;
    <A, B, C, D, E, F, G, H, I, J>(a: A, ab: (this: void, a: A) => B, bc: (this: void, b: B) => C, cd: (this: void, c: C) => D, de: (this: void, d: D) => E, ef: (this: void, e: E) => F, fg: (this: void, f: F) => G, gh: (this: void, g: G) => H, hi: (this: void, h: H) => I, ij: (this: void, i: I) => J): J;
};
